/**
 * Copyright (c) 2019 Tecnalia Research & Innovation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 * 
 * Contributors:
 *     Tecnalia Research & Innovation - initial API and implementation
 * 
 */
package org.eclipse.papyrus.robotics.faultinjection.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.eclipse.papyrus.robotics.faultinjection.util.FaultinjectionAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FaultinjectionItemProviderAdapterFactory extends FaultinjectionAdapterFactory
		implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FaultinjectionItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.FaultList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FaultListItemProvider faultListItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.FaultList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFaultListAdapter() {
		if (faultListItemProvider == null) {
			faultListItemProvider = new FaultListItemProvider(this);
		}

		return faultListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.Readout} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReadoutItemProvider readoutItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.Readout}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReadoutAdapter() {
		if (readoutItemProvider == null) {
			readoutItemProvider = new ReadoutItemProvider(this);
		}

		return readoutItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.StuckAt0Fault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StuckAt0FaultItemProvider stuckAt0FaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.StuckAt0Fault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStuckAt0FaultAdapter() {
		if (stuckAt0FaultItemProvider == null) {
			stuckAt0FaultItemProvider = new StuckAt0FaultItemProvider(this);
		}

		return stuckAt0FaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.StuckAtLastValueFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StuckAtLastValueFaultItemProvider stuckAtLastValueFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.StuckAtLastValueFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStuckAtLastValueFaultAdapter() {
		if (stuckAtLastValueFaultItemProvider == null) {
			stuckAtLastValueFaultItemProvider = new StuckAtLastValueFaultItemProvider(this);
		}

		return stuckAtLastValueFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.StuckAtValueFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StuckAtValueFaultItemProvider stuckAtValueFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.StuckAtValueFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStuckAtValueFaultAdapter() {
		if (stuckAtValueFaultItemProvider == null) {
			stuckAtValueFaultItemProvider = new StuckAtValueFaultItemProvider(this);
		}

		return stuckAtValueFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.InvertedFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InvertedFaultItemProvider invertedFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.InvertedFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInvertedFaultAdapter() {
		if (invertedFaultItemProvider == null) {
			invertedFaultItemProvider = new InvertedFaultItemProvider(this);
		}

		return invertedFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.TooHighFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TooHighFaultItemProvider tooHighFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.TooHighFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTooHighFaultAdapter() {
		if (tooHighFaultItemProvider == null) {
			tooHighFaultItemProvider = new TooHighFaultItemProvider(this);
		}

		return tooHighFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.TooLowFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TooLowFaultItemProvider tooLowFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.TooLowFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTooLowFaultAdapter() {
		if (tooLowFaultItemProvider == null) {
			tooLowFaultItemProvider = new TooLowFaultItemProvider(this);
		}

		return tooLowFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.RampUpFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RampUpFaultItemProvider rampUpFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.RampUpFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRampUpFaultAdapter() {
		if (rampUpFaultItemProvider == null) {
			rampUpFaultItemProvider = new RampUpFaultItemProvider(this);
		}

		return rampUpFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.RampDownFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RampDownFaultItemProvider rampDownFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.RampDownFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRampDownFaultAdapter() {
		if (rampDownFaultItemProvider == null) {
			rampDownFaultItemProvider = new RampDownFaultItemProvider(this);
		}

		return rampDownFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.BitFlipFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BitFlipFaultItemProvider bitFlipFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.BitFlipFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBitFlipFaultAdapter() {
		if (bitFlipFaultItemProvider == null) {
			bitFlipFaultItemProvider = new BitFlipFaultItemProvider(this);
		}

		return bitFlipFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.OscillationFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OscillationFaultItemProvider oscillationFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.OscillationFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOscillationFaultAdapter() {
		if (oscillationFaultItemProvider == null) {
			oscillationFaultItemProvider = new OscillationFaultItemProvider(this);
		}

		return oscillationFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.RandomFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RandomFaultItemProvider randomFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.RandomFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRandomFaultAdapter() {
		if (randomFaultItemProvider == null) {
			randomFaultItemProvider = new RandomFaultItemProvider(this);
		}

		return randomFaultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.papyrus.robotics.faultinjection.DelayFault} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DelayFaultItemProvider delayFaultItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.papyrus.robotics.faultinjection.DelayFault}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDelayFaultAdapter() {
		if (delayFaultItemProvider == null) {
			delayFaultItemProvider = new DelayFaultItemProvider(this);
		}

		return delayFaultItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (faultListItemProvider != null)
			faultListItemProvider.dispose();
		if (readoutItemProvider != null)
			readoutItemProvider.dispose();
		if (stuckAt0FaultItemProvider != null)
			stuckAt0FaultItemProvider.dispose();
		if (stuckAtLastValueFaultItemProvider != null)
			stuckAtLastValueFaultItemProvider.dispose();
		if (stuckAtValueFaultItemProvider != null)
			stuckAtValueFaultItemProvider.dispose();
		if (invertedFaultItemProvider != null)
			invertedFaultItemProvider.dispose();
		if (tooHighFaultItemProvider != null)
			tooHighFaultItemProvider.dispose();
		if (tooLowFaultItemProvider != null)
			tooLowFaultItemProvider.dispose();
		if (rampUpFaultItemProvider != null)
			rampUpFaultItemProvider.dispose();
		if (rampDownFaultItemProvider != null)
			rampDownFaultItemProvider.dispose();
		if (bitFlipFaultItemProvider != null)
			bitFlipFaultItemProvider.dispose();
		if (oscillationFaultItemProvider != null)
			oscillationFaultItemProvider.dispose();
		if (randomFaultItemProvider != null)
			randomFaultItemProvider.dispose();
		if (delayFaultItemProvider != null)
			delayFaultItemProvider.dispose();
	}

}
